module dc_trace

    use dc_types, only: token
    implicit none
    private

    logical, save         :: lfirst = .true.         ! tO
    integer, save, public :: dbg = -1                ! o͑uԍ
    integer, save         :: level = 0               ! Tu[`x
    integer, parameter    :: trace_stack_size = 128  ! őKw
    character(token), save:: table(trace_stack_size) ! Kw̃vO
    character(1), parameter :: head    = '#'         ! s
    character(2), parameter :: indent  = '| '        ! 
    character(2), parameter :: meshead = '|-'        ! DbgMessage ps

    public:: BeginSub, EndSub, Debug, SetDebug, DbgMessage, Dbg_Scratch
    public:: SubLevel, DataDump

    interface DataDump
       module procedure DataD1Dump, DataD2Dump, DataD3Dump
    end interface

contains

    !-------------------------------------------------------
    ! vO̊KwxԂ
    !-------------------------------------------------------
    integer function SubLevel() result(result)
        result = level
    end function SubLevel

    !-------------------------------------------------------
    ! fobObZ[W̖
    !-------------------------------------------------------
    subroutine Dbg_Scratch(on)
        logical, intent(in):: on
        integer, save:: saved_dbg = -1
        logical:: x, p
        character(80):: line
        integer:: ios
    continue
        if (on) then
           if (dbg < 0) return
           saved_dbg = dbg
           ! L 1 ` 99 ̑uԍ̓̑傫߂̒lݒ (?)
           dbg = 98
           do
              inquire(unit=dbg, exist=x, opened=p)
              ! uԍ dbg ڑ\ŁAڑ̏ꍇ
              if (x .and. .not. p) then
                 ! uԍ deg XNb`t@CƂĊJB
                 !    XNb`t@CƂ́AȊOt@CłB
                 !      ͖OȂ̈ꎞt@CłAJĂ
                 !      Ԃ݂B܂AvOI
                 !      ݂ȂȂB
                 open(unit=dbg, status='SCRATCH')
                 ! Jo΂ŏIB
                 return
              endif
              ! uԍ dbg psA܂͗pς̏ꍇ 0 ȉ
              ! Ȃ܂ dbg - 1 ČJԂB
              dbg = dbg - 1
              if (dbg < 0) exit
           enddo
           ! uԍ dbg JȂꍇAdbg  saved_dbg 
           dbg = saved_dbg
           saved_dbg = -1
        else
           ! ȑOɑuԍ dbg = 98`0 ŃXNb`t@CJĂ
           ! Ȃ΂ŏI
           if (saved_dbg < 0) return
           ! uԍ dbg ɐڑꂽXNb`t@C̊Jnʒu
           ! ɈʒutBG[u100 continuev
           rewind(dbg, err=100)
           do
              ! uԍ dbg ɐڑꂽXNb`t@C̈s
              ! line 
              read(dbg, '(A)', iostat=ios) line
              if (ios /= 0) exit
              ! line 𑕒uԍ saved_dbg ֏oB
              write(saved_dbg, '(A)', iostat=ios) trim(line)
              if (ios /= 0) exit
           enddo
           100 continue
           close(dbg, iostat=ios)
           ! Ō dbg  saved_dbg 
           dbg = saved_dbg
           saved_dbg = -1
        endif
    end subroutine Dbg_Scratch

    !-------------------------------------------------------
    ! fobO[hIɂTu[`
    !-------------------------------------------------------
    subroutine SetDebug(debug)
        integer, intent(in), optional:: debug
        integer:: ios
        if (present(debug)) then
            ! debug ^鎞͑uԍƂ deg pB
            dbg = debug
            write(dbg, "(A, 'SetDebug: dbg =', i4)", iostat=ios) &
                 & trim(head), dbg
            if (ios == 0) return
        else
            ! debug ^ꖳ͑uԍ 0 (WG[o)
            dbg = 0
            write(dbg, "(A, 'SetDebug: dbg = 0')", iostat=ios) trim(head)
            if (ios == 0) return
            ! uԍ 0 ւ̏o͂s瑕uԍ 6 (Wo)
            dbg = 6
            write(dbg, "(A, 'SetDebug: dbg = 6')", iostat=ios) trim(head)
            if (ios == 0) return
        endif
        ! OƂ dbg ̏
        dbg = -1
    end subroutine SetDebug

    !-------------------------------------------------------
    ! fobN[hǂ̐ff
    !-------------------------------------------------------
    logical function Debug() result(result)
        result = dbg >= 0
    end function Debug

    !-------------------------------------------------------
    ! 
    !-------------------------------------------------------
    subroutine initialize
        table(:) = ' '
        lfirst = .false.
    end subroutine initialize

    !-------------------------------------------------------
    ! vOJñbZ[Wo (level + 1)
    !-------------------------------------------------------
    subroutine BeginSub(name, fmt, i, r, d, L, s, n, c1, c2, c3)
        use dc_types, only: string
        use dcstring_base, only: vstring
        use dc_string, only: cprintf
        character(*), intent(in)          :: name
        character(*), intent(in), optional:: fmt
        integer,      intent(in), optional:: i(:), n(:)
        real,         intent(in), optional:: r(:)
        real(8),      intent(in), optional:: d(:)
        logical,      intent(in), optional:: L(:)
        type(vstring),intent(in), optional:: s(:)
        character(*), intent(in), optional:: c1, c2, c3
        character(string) :: cbuf
    continue
        if (lfirst) call initialize
        if (debug()) then
            if (present(fmt)) then
                cbuf = cprintf(fmt, i, r, d, L, s, n, c1, c2, c3)
                write(dbg, "(A, A, 'call ', A, ' : ', A)") trim(head), &
                    & repeat(indent, level), trim(name), trim(cbuf)
            else
                write(dbg, "(A, A, 'call ',A)") trim(head), & 
                    & repeat(indent, level), trim(name)
            endif
        endif
        ! call errtra ! --- for Fujitsu debug
        if (level > size(table)) return
        level = level + 1
        table(level) = name
    end subroutine BeginSub

    !-------------------------------------------------------
    ! vOĨbZ[Wo (level - 1)
    !-------------------------------------------------------
    subroutine EndSub(name, fmt, i, r, d, L, s, n, c1, c2, c3)
        use dc_types, only: string
        use dcstring_base, only: vstring
        use dc_string, only: cprintf
        character(*), intent(in)          :: name
        character(*), intent(in), optional:: fmt
        integer,      intent(in), optional:: i(:), n(:)
        real,         intent(in), optional:: r(:)
        real(8),      intent(in), optional:: d(:)
        logical,      intent(in), optional:: L(:)
        type(vstring),intent(in), optional:: s(:)
        character(*), intent(in), optional:: c1, c2, c3
        character(string):: cbuf
    continue
        if (lfirst) call initialize
        ! call errtra ! --- for Fujitsu debug
        if (level <= 0) then
            write(*, "(A, 'Warning EndSub[',A,'] without BeginSub')") &
                & trim(head), trim(name)
        else if (name /= table(level)) then
            write(*, "(A, 'Warning EndSub[',A,'] but tos[',A,']')") &
                & trim(head), trim(name), trim(table(level))
        else
            level = level - 1
        endif
        if (debug()) then
            if (present(fmt)) then
                cbuf = cprintf(fmt, i, r, d, L, s, n, c1, c2, c3)
                write(dbg, "(A, A, 'end ', A, ' : ', A)") trim(head), &
                    & repeat(indent, level), trim(name), trim(cbuf)
            else
                write(dbg, "(A, A, 'end ', A)") trim(head), &
                    & repeat(indent, level), trim(name)
            endif
        endif
    end subroutine EndSub

    !-------------------------------------------------------
    ! bZ[Wo (level } 0)
    !-------------------------------------------------------
    subroutine DbgMessage(fmt, i, r, d, L, s, n, c1, c2, c3)
        use dc_types, only: string
        use dcstring_base, only: vstring
        use dc_string, only: cprintf, toChar
        character(*), intent(in)          :: fmt
        integer,      intent(in), optional:: i(:), n(:)
        real,         intent(in), optional:: r(:)
        real(8),      intent(in), optional:: d(:)
        logical,      intent(in), optional:: L(:)
        type(vstring),intent(in), optional:: s(:)
        character(*), intent(in), optional:: c1, c2, c3
        character(string):: cbuf
        character(string):: meshead_tmp
        integer          :: meshead_len
    continue
        if (.not. debug()) return
        cbuf = cprintf(fmt, i, r, d, L, s, n, c1, c2, c3)
        if (level < 1) then
           meshead_tmp = ''
           meshead_len = 0
        else
           meshead_tmp = meshead
           meshead_len = len(meshead)
        endif
        write(dbg, "(A, A, A, A)") & 
             & trim(head), repeat( indent, max(level-1, 0) ), &
             & meshead_tmp(1:meshead_len), trim(cbuf)
    end subroutine DbgMessage


    !-------------------------------------------------------
    ! f[^o (level } 0)
    !-------------------------------------------------------
    subroutine DataD3Dump(header, d, strlen, multi)
      use dc_types,      only: string
      character(*), intent(in)          :: header  ! f[^̖
      real(8),      intent(in)          :: d(:,:,:)! {xRf[^
      integer,      intent(in), optional:: strlen  ! s̕
      integer,      intent(in), optional:: multi(:)! ʂ̎Y

      integer, allocatable :: total(:)
      integer              :: k

    continue
      if (.not. debug()) return

      if (present(multi)) then
         allocate( total(size(multi)+1) )
         total(2:size(multi)+1) = multi(:)
      else
         allocate( total(1) )
      endif

      do k = 1, size( d(:,:,:), 3 )
         total(1) = k
         call DataDump(header, d(:,:,k), strlen=strlen, multi=total(:))
      enddo

      deallocate( total )

    end subroutine DataD3Dump

    subroutine DataD2Dump(header, d, strlen, multi)
      use dc_types,      only: string
      character(*), intent(in)          :: header  ! f[^̖
      real(8),      intent(in)          :: d(:,:)  ! {xQf[^
      integer,      intent(in), optional:: strlen  ! s̕
      integer,      intent(in), optional:: multi(:)! ʂ̎Y

      integer, allocatable :: total(:)
      integer              :: j

    continue
      if (.not. debug()) return

      if (present(multi)) then
         allocate( total(size(multi)+1) )
         total(2:size(multi)+1) = multi(:)
      else
         allocate( total(1) )
      endif

      do j = 1, size( d(:,:), 2 )
         total(1) = j
         call DataDump(header, d(:,j), strlen=strlen, multi=total(:))
      enddo

      deallocate( total )

    end subroutine DataD2Dump

    subroutine DataD1Dump(header, d, strlen, multi)
      use dc_types,      only: string
      use dc_string,     only: toChar
      character(*), intent(in)          :: header  ! f[^̖
      real(8),      intent(in)          :: d(:)    ! {xPf[^
      integer,      intent(in), optional:: strlen  ! s̕
      integer,      intent(in), optional:: multi(:)! ʂ̎Y

      integer          :: i, j

      character(string):: unit    ! f[^
      character(string):: unitbuf ! f[^obt@
      integer          :: ucur    ! unit ɏꂽ
      character(string):: cbuf    ! read/write ̃obt@
      integer          :: stat    ! Xe[^X

      logical  :: first  ! 1ڂ̃f[^ǂ
      integer  :: begini ! 1ڂ̃f[^̓Y
      integer  :: endi   ! Ō̃f[^̓Y

      character(string):: cmulti ! Yp
      character(string):: cout   ! o͂镶

      character(string):: meshead_tmp
      integer          :: meshead_len
    continue
      if (.not. debug()) return

      ! 
      unit    = ''
      unitbuf = ''
      ucur    = 0
      stat    = 0
      first = .true.

      cmulti = ''

      ! fobObZ[Wwb_̍쐬B
      if (level < 1) then
         meshead_tmp = ''
         meshead_len = 0
      else
         meshead_tmp = meshead
         meshead_len = len(meshead)
      endif

      ! Yp쐬
      if (present(multi)) then
         do j = 1, size(multi)
            cmulti = trim(cmulti) // ', ' // trim(  toChar( multi(j) )  )
         enddo
      endif

      i = 1
      Dim_1_Loop : do
         if (first) begini = i
         endi = i
         write(cbuf, "(g40.20)") d(i)
         if (.not. first) cbuf = ', ' // adjustl(cbuf)
         unitbuf = unit
         call append(unit, ucur, trim(adjustl(cbuf)), stat, strlen)

         if ( stat /= 0 .or. i == size( d(:) ) ) then
            ! ڂ́AI[o[ł̂܂܏óB
            if (first) then
               cout = header // '(' &
                    &   // trim(toChar(begini)) &
                    &   // trim(cmulti) &
                    &   // ')=' // trim(unit)
            ! ڈȍ~́AI[o[͎̂
            elseif (stat /= 0 .and. begini == endi-1) then
               cout = header // '(' &
                    &   // trim(toChar(begini)) &
                    &   // trim(cmulti) &
                    &   // ')='// trim(unitbuf)
               ! 1߂
               i = i - 1
            elseif (stat /= 0 .and. begini /= endi-1) then
               cout = header // '(' &
                    &   // trim(toChar(begini)) // '-' &
                    &   // trim(toChar(endi-1)) &
                    &   // trim(cmulti) &
                    &   // ')=' // trim(unitbuf)
               ! 1߂
               i = i - 1
            ! i  size(d) ܂œBꍇ̂܂܏óB
            elseif ( i == size( d(:) ) ) then
               cout = header // '(' &
                    &   // trim(toChar(begini)) // '-' &
                    &   // trim(toChar(endi))   &
                    &   // trim(cmulti) &
                    &   // ')='// trim(unit)
            endif

            write(dbg, "(A, A, A, A)") & 
                 & trim(head), repeat( indent, max(level-1, 0) ), &
                 & meshead_tmp(1:meshead_len), trim(cout)

            ! unit, unitbuf NA
            unit    = ''
            unitbuf = ''
            ucur    = 0
            first = .true.
         else
            first = .false.
         endif
         if (i == size( d(:) ) ) exit Dim_1_Loop
         i = i + 1
      enddo Dim_1_Loop
    end subroutine DataD1Dump


    !
    ! Iɂ DataDump ̓֐B
    ! unit  val tB̍ہAunit ̍ő啶񒷂zꍇ
    ! ɂ stat = 2 ԂB
    !
    subroutine append(unit, ucur, val, stat, strlen)
      character(*), intent(inout):: unit ! ŏIIɕԂ镶
      integer,      intent(inout):: ucur ! unit ̕
      character(*), intent(in)   :: val  ! unit ɕt镶
      integer,      intent(out)  :: stat ! Xe[^X
      integer,      intent(in), &
           &        optional     :: strlen ! ̎蓮w

      integer                    :: wrsz ! val ̕
      continue
      ! unit ̍ő咷zꍇɂ stat = 2 ԂB
      if (present(strlen)) then
         if (ucur >= strlen) then
            stat = 2
            return
         endif
      else
         if (ucur >= len(unit)) then
            stat = 2
            return
         endif
      endif
      ! 펞̏B
      ! unit ̒zꍇl unit  val tB
      wrsz = min(len(val), len(unit) - ucur)
      unit(1+ucur: wrsz+ucur) = val(1: wrsz)
      ucur = ucur + wrsz
      stat = 0
      if (wrsz < len(val)) stat = 1
    end subroutine append

end module
